Subject: Re: [Tsvwg] sctp error check, again

From: Randall Stewart at work <[email-masked]>
Date: Wed, 13 Jun 2001 15:47:08 -0500

Ian:

We can always add a digest chunk.. I have no problem with
this and we can easily have this in a seperate document.
I don't see that we need to tie it to our choices that
Lyndon presented ... i.e. 1, 2 or 3...

We COULD add a fourth catagory... but I think it best
to keep it a bit simpler...

R

Ian Rytina wrote:
> 
> On this issue, a quote from RFC2960, Section 1.3.6 Packet Validation :-
> 
> "A mandatory Verification Tag field and a 32 bit checksum field (see
> Appendix B for a description of the Adler-32 checksum) are included
> in the SCTP common header.  The Verification Tag value is chosen by
> each end of the association during association startup.  Packets
> received without the expected Verification Tag value are discarded,
> as a protection against blind masquerade attacks and against stale
> SCTP packets from a previous association.  The Adler-32 checksum
> should be set by the sender of each SCTP packet to provide additional
> protection against data corruption in the network.  The receiver of
> an SCTP packet with an invalid Adler-32 checksum silently discards
> the packet."
> 
> Since the checksum is used "to provide additional protection against
> data corruption in the network", please explain why the use of a security
> digest a separate issue. Or is this paragraph in RFC2960 incorrect ?
> 
> Randall Stewart wrote:
> 
> > Yes,
> >
> > Lets leave this whole digest chunk issue out of
> > play here... it just confuses the issue. We then
> > our down to two options....
> >
> > #1 leave things as they are - 5 in favor
> >
> > #2 change to CRC-32 - 18 in favor..
> >
> > Anything to do with digest chunks can be considered
> > seperately in say one of Dougs drafts... lets do
> > seperate threads to discuss please ... and instead
> > focus on getting consensus on this single issue
> > i.e. what (if any) to change the SCTP checksum to...
> >
> > Scott/Allison: Is this a enough of a consensus for
> > CRC-32.. if so I will make the appropriate changes
> > the draft chip and I have ready and get it submitted??
> >
> > R
> >
> > Lyndon Ong wrote:
> > >
> > > Well, we can pretty much eliminate (2).  A digest
> > > should be considered as a separate issue, I think.
> > >
> > > Cheers,
> > >
> > > Lyndon
> > > --
> > >
> > > On Fri, 08 Jun 2001 12:13:50   Randall Stewart wrote:
> > > >Douglas:
> > > >
> > > >If you would like me to open another catagory i.e.
> > > >
> > > >Wants CRC-32 OR a Digest:
> > > >
> > > >I suppose I can.. but at this point, considering the
> > > >comments on the list.. i.e. have all faded.. I
> > > >think we are going to need to ask the chairs to
> > > >look at these results and determine if we have a
> > > >rough consensus...or not...
> > > >
> > > >I don't see that any more comments
> > > >are arriving...  your postion change would make things:
> > > >
> > > >Total 1) 5
> > > >Total 2) 1
> > > >Total 3) 18
> > > >
> > > >Total Double ballots) 4
> > > >Total unspecified) 2
> > > >
> > > >I think that double ballot people should be dis-qualified...
> > > >since we need a consensus for one of the choices.. not multiple..
> > > >
> > > >We can always proceed in parrallel with a CRC/Digest chunk
> > > >and gage that seperate from changing the base sum...
> > > >
> > > >Has it stands now, it seems to me that we MAY have consensus for
> > > >CRC-32... but I must leave that to the chairs....
> > > >
> > > >Scott/Allision? Do you think that we will get any more
> > > >results?
> > > >
> > > >Chip and I have the draft for just the checksum change
> > > >ready... all we need is for you to tell us what consensus is..
> > > >or that we don't have it yet :>
> > > >
> > > >R
> > > >
> > > >Douglas Otis wrote:
> > > >>
> > > >> Randall,
> > > >>
> > > >> You can put me into the CRC-32 camp but I would like to also keep
> > > >> consideration of placement and digest open.  If this process is to be
> > > >> offloaded either in software or hardware, the number of passes through
> > > >> memory is important for performance.  Doing both a digest and packet check
> > > >> within the header will ensure two passes are always required.  I even
> > > >> suspect that with respect to encription, a very good crc is not helpful at
> > > >> that point.  Although it is not a problem that we are facing today, I wonder
> > > >> how this is to be done at 10GE.  Considerations as how often memory must be
> > > >> touched in the process may be a concern.  Also if there is a congestion
> > > >> problem causing a need for a path switch, this process now has a double duty
> > > >> of rebuilding these packets without a packet level digest which does seem
> > > >> possible.  If no header is used to allow check options, then placing the
> > > >> check at the end of the frame has advantages in that a word size pipe can
> > > >> handle two algorithms at once.
> > > >>
> > > >> Doug
> > > >>
> > > >> > Good Morning tsvwg :-)
> > > >> >
> > > >> > Coffee firmly in hand I now report once again
> > > >> > the current "straw-poll" standings on this thread :-0
> > > >> >
> > > >> > ****************************************************
> > > >> > PLEASE SOUND OFF IF YOU ARE IN THE WRONG
> > > >> > CATAGORY!!!! OR I HAVE MIS-READ YOU..
> > > >> > ***************************************************
> > > >> > Option 1 or 2:
> > > >> > --------------
> > > >> > Qiaobing Xie (wants the same or Modifed-Alder )
> > > >> >
> > > >> > Option 1 or 3:
> > > >> > --------------
> > > >> > Klaus Gradischnig (wants keep the same or CRC-32)
> > > >> >
> > > >> > Wants Others to decide/No-comment :>
> > > >> > ------------------------------------
> > > >> > Chip Sharp
> > > >> >
> > > >> >
> > > >> > No preference but wants only 1:
> > > >> > -------------------------------
> > > >> > Kacheong Poon ( wants only one sum, no options)
> > > >> >
> > > >> > Still Unsure how to classify:
> > > >> > ---------------------------------------------------
> > > >> > Ran Atkinson (wants justification for any switch)
> > > >> >
> > > >> >
> > > >> >
> > > >> > Option 1 - leave Adler-32:
> > > >> > --------------------------
> > > >> > Ian Rytina
> > > >> > Michael Tuxen
> > > >> > Shymall Prasad
> > > >> > Hanns J Schwarzbauer
> > > >> > Alf Heidermark (Since he agrees with Hanns??)
> > > >> >
> > > >> > Option 2 - Modifed Adler-32 or Fletcher-16:
> > > >> > -------------------------------------------
> > > >> > Gareth Kiely
> > > >> >
> > > >> >
> > > >> > Option 3 - CRC-32:
> > > >> > ------------------
> > > >> > Me
> > > >> > Michael Ramalho
> > > >> > Lloyd Wood
> > > >> > Jonathan Wood
> > > >> > Jim Williams
> > > >> > Stephen Bailey
> > > >> > La Monte Yarroll
> > > >> > Ivan Arias Rodriguez
> > > >> > Andreas Jungmaier
> > > >> > David Black
> > > >> > David Reed ** with preference for a MD5 Digest?
> > > >> > Douglas Otis ** with preference for a MD5 Digest?
> > > >> > David Lehmann
> > > >> > Brian Bidulock
> > > >> > Richard A. Adams
> > > >> > Robert Fairlie-Cuninghame
> > > >> > Wolfgang Schruefer
> > > >> > John Loughney
> > > >> > Laurent Glade
> > > >> >
> > > >> > ---------------------------------------------------
> > > >> >
> > > >> > Total 1) 5
> > > >> >
> > > >> > Total 2) 1
> > > >> >
> > > >> > Total 3) 19
> > > >> >
> > > >> > Total Double ballots) 3
> > > >> > Total unspecified) 2
> > > >> >
> > > >> > ---------------------------------------------------
> > > >> > Total folks commenting on: 30
> > > >> > ---------------------------------------------------
> > > >> >
> > > >> >
> > > >> > --
> > > >> > Randall R. Stewart
> > > >> > [email-masked] 815-342-5222 (cell phone)
> > > >> >
> > > >> > _______________________________________________
> > > >> > tsvwg mailing list
> > > >> > [email-masked]
> > > >> > http://www1.ietf.org/mailman/listinfo/tsvwg
> > > >> >
> > > >
> > > >--
> > > >Randall R. Stewart
> > > >[email-masked] 815-342-5222 (cell phone)
> > > >
> > > >_______________________________________________
> > > >tsvwg mailing list
> > > >[email-masked]
> > > >http://www1.ietf.org/mailman/listinfo/tsvwg
> > > >
> > >
> > > Join 18 million Eudora users by signing up for a free Eudora Web-Mail account at http://www.eudoramail.com
> >
> > --
> > Randall R. Stewart
> > [email-masked] 815-342-5222 (cell phone)
> >
> > _______________________________________________
> > tsvwg mailing list
> > [email-masked]
> > http://www1.ietf.org/mailman/listinfo/tsvwg
> 
> _______________________________________________
> tsvwg mailing list
> [email-masked]
> http://www1.ietf.org/mailman/listinfo/tsvwg

-- 
Randall R. Stewart
[email-masked] 815-342-5222 (cell phone)

_______________________________________________
tsvwg mailing list
[email-masked]
http://www1.ietf.org/mailman/listinfo/tsvwg

---

From: Randall Stewart at work <[email-masked]>
Date: Wed, 13 Jun 2001 15:57:57 -0500

Ian Rytina wrote:
> 
> Randy,
> 
> How on earth do you claim that this is even anywhere near
> consensus ? 

Please read a bit closer Ian, I was asking Scott and Allision
if this was consensus... I would like to get there feel on it.
I did not claim it was consensus but that we were approaching
it..

> For a start, why do you invalidate double votes or
> those that are not sure ?

I will be more than glad to count the double votes as
a vote in each catagory.. I don't really think this is
very fair... the idea was to choose 1 not choose several :)

If the WG wants to count double votes lets add a 1/2 vote for
one and a 1/2 vote for the second.... that seems fair to me
and makes it so that if you DO choose more than 1 your vote
is split...that way no one gets more than one vote :)

> Double votes are completely valid, e.g.
> 1&2 means "I want a checksum solution on the transport layer, not
> a CRC solution", 2&3 means "if there's a problem, fix it, don't care
> how". Those who have voted for "not sure" means that they need
> more information before deciding.

I don't think I have seen any not sure's. I try to put down
names and comments in all the voting I am reporting. I am not
really biased in this.. though you seem to read me this way :0
> 
> So, using your figures, not including a few that came in today, I
> could (if I wanted) say that the results were :-

At the time I sent this it included all names that had specified a
preference. I will go throught the rest of my un-read email (I have
been traveling again ...sigh..) and then I will re-tabulate with
adding the 1/2 votes in as well (with names in each catagory).

I think it is important to list WHO in any tabulation. Just throwing
out numbers does not do justice to the wg. Giving the name and then
the totals is I think better. This gives folks a chance to realize
they are being mis-counted... or change there vote for any
other reason...

> 
> For CRC-32 = 18
> Not For CRC-32 (for whatever reason) = 12
> 
> The consequence of this is clearly "no consensus = no change". So I
> could say that we move forward with no change and forget about this issue.

I don't get your numbers here.. please if you think I am wrong
point out the names in each of the catagory... I don't think you can
count votes in 2 and 1 together.. The choices are

1 2 or 3...

> 
> However, I believe that most of the "Not For"s are all reasonable people (they
> seem to be, anyway.....). Most have stated that, while we understand that
> there MAY be a theoretical problem, and we also understand why there may
> be a theoretical problem, a few acedemic papers are not enough to convince
> us to change, especially since this exact issue has been discussed before in
> the development of SCTP.

Well, whom have I listed wrong Ian? I put down as acurately as possible
the folks that have come out either way. Anyone that sees I have them
tabulated in the wrong catagory SHOULD speak up and correct it!!

> 
> I believe from some of the comments on the list that the pro-CRCers have
> shown willingness to provide more evidence - let's wait for that before falsely
> declaring consensus.
> 

Excuse me. I don't see this has a valid argument. We have quite a
bit of information from Jonathan Stone and Craig Partridge on
this. Adler-32 is weak in small messages. Douglas Otis did testing
and reported results as to how many errors he encountered...

I realize that you may not like the outcomes here.. please point
out to me who I have mis-represented and this will convince
me that we are far from consenus...

I will post an update later today and you can PLEASE comment
on which name is in the wrong catagory...

R